package com.jiuqi.dna.ide.designer.policies;

import com.jiuqi.dna.ide.designer.commands.DesignerElementCreateCommand;
import com.jiuqi.dna.ide.designer.commands.FigureElementChangeConstraintCommand;
import com.jiuqi.dna.ide.designer.elements.ICompositeElement;
import com.jiuqi.dna.ide.designer.elements.IFigureElement;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.XYLayoutEditPolicy;
import org.eclipse.gef.requests.ChangeBoundsRequest;
import org.eclipse.gef.requests.CreateRequest;

/* loaded from: com_jiuqi_dna_ide_designer_policies.jar:com/jiuqi/dna/ide/designer/policies/DesignerXYLayoutEditPolicy.class */
public class DesignerXYLayoutEditPolicy extends XYLayoutEditPolicy {
    protected Command createChangeConstraintCommand(ChangeBoundsRequest request, EditPart child, Object constraint) {
        Object type = request.getType();
        Object model = child.getModel();
        if ((model instanceof IFigureElement) && (constraint instanceof Rectangle)) {
            IFigureElement element = (IFigureElement) model;
            Rectangle bounds = (Rectangle) constraint;
            if ("move".equals(type) || "move children".equals(type) || "resize".equals(type) || "resize children".equals(type)) {
                return new FigureElementChangeConstraintCommand(element, bounds.x, bounds.y, bounds.width, bounds.height);
            }
        }
        return super.createChangeConstraintCommand(request, child, constraint);
    }

    protected Command createChangeConstraintCommand(EditPart child, Object constraint) {
        return null;
    }

    protected Command getCreateCommand(CreateRequest request) {
        Object newObject = request.getNewObject();
        Object parentModel = getHost().getModel();
        if ((newObject instanceof IFigureElement) && (parentModel instanceof ICompositeElement)) {
            IFigureElement element = (IFigureElement) newObject;
            ICompositeElement parent = (ICompositeElement) parentModel;
            Rectangle bounds = (Rectangle) getConstraintFor(request);
            if (!bounds.isEmpty()) {
                element.setBounds(bounds);
            } else {
                Rectangle rect = new Rectangle(bounds.x, bounds.y, element.getWidth(), element.getHeight());
                element.setBounds(rect);
            }
            return new DesignerElementCreateCommand(element, parent);
        }
        return null;
    }
}
